//跟着冲哥学AI8051U的第六天-IO定时器中断
//作者：xiaoabin
//日期：2024年12月3日22点12分

#include "ai8051u.h" 			//调用头文件
#include "stc32_stc8_usb.h"		//USB CDC 头文件
#include "intrins.h"            //调用头文件

#define u8 unsigned char
#define u16 unsigned int

char *USER_DEVICEDESC = NULL;
char *USER_PRODUCTDESC = NULL;
char *USER_STCISPCMD = "@STCISP#";

u8 count = 0;			//按键计数；	1双0单
u8 state = 0;			//功德时期状态  1双0单
u16 gongde_count = 0;    //当前功德数

void Delay20ms(void)	//@24.000MHz delay20ms Delay20ms();
{
	unsigned long edata i;

	_nop_();
	_nop_();
	i = 119998UL;
	while (i) i--;
}

//函数声明:
void Timer0_Init_1S(void);		//1秒@24.000MHz
void Timer0_Init_2S(void);		//2秒@24.000MHz

void main (void)				//主函数
{  
	
    WTST = 0;  					//设置程序指令延时参数，赋值为0可将CPU执行指令的速度设置为最快
    EAXFR = 1; 					//扩展寄存器(XFR)访问使能
    CKCON = 0; 					//提高访问XRAM速度
	
	P_SW2 |= 0x80;              //B7位置1，使能访问XFR寄存器
	
	P0M0 = 0x00; P0M1 = 0x00; 	
    P1M0 = 0x00; P1M1 = 0x00; 
    P2M0 = 0x00; P2M1 = 0x00; 
    P3M0 = 0x00; P3M1 = 0x00; 
    P4M0 = 0x00; P4M1 = 0x00; 
    P5M0 = 0x00; P5M1 = 0x00; 
    P6M0 = 0x00; P6M1 = 0x00; 
    P7M0 = 0x00; P7M1 = 0x00; 	//将所有的端口都设置成准双向口，方便后期的使用。

	usb_init();					//USB CDC 接口配置
	
	IE2 |= 0x80;                //使能USB中断
	
    EA = 1; 					//EA |= 0X80;
	
	P40 = 0;					//打开LED开关
	
	while (DeviceState != DEVSTATE_CONFIGURED);     //等待USB完成配置
	
    while (1)
    {
        if (bUsbOutReady)					//如果接收到了一个数据
        {
            //USB_SendData(UsbOutBuffer,OutNumber);   //发送数据缓冲区，长度（接收数据原样返回, 用于测试）
            usb_OUT_done();					//清除当前的接收区
        }
		
		/*	课后小练习：按键1：33	 按键2：35
		1：按下33，串口显示“双倍功德时间”，再次按下按键显示“单倍功德时间”	ps（计算当前按键次数）
		2：按下35，双倍功德时间下显示“功德+2 当前功德：xxx”					ps（判断单双功德）
		3：按下35，单倍功德时间下显示“功德+1 当前功德：xxx”					ps（判断当前功德时期）
		4：功德+1时，LED点亮1秒后熄灭表示功能成功点亮；						ps（需要定时1秒钟）
		5：功德+2时，LED点亮1秒后熄灭表示功能成功点亮； 					ps（需要定时2秒钟）
		*/
		
		//思路：分成两个if，分别对应按键1和2，在分析各部分的功能，然后编写相对应的代码。
		//存在的BUG：在点亮灯的时间内，快速积累功德，只会被认定为一次加功德。
		//已修改bug：变成了无论按下多少次按键，只要在功德没有点亮前都不会增加。（好像有点脱离题目了？）
		
		//按键1控制逻辑
		if(P33 == 0)
		{
			Delay20ms();				//消抖
			if(P33 == 0)
			{
				count += 1;
				count %= 2;		//判断单双功德时间 1双0单
				if(count)		//判断
				{
					state = 2;	//双倍功德时间
					printf("双倍功德时间!\r\n");
				}
				else
				{
					state = 1;	//单倍功德时间
					printf("单倍功德时间!\r\n");
				}
			}
			while(P33 == 0);			//判断按键状态是不是改变了
		}
		
		//按键2控制逻辑
		if(P35 == 0)
		{
			Delay20ms();				//消抖
			if(P35 == 0)
			{
				if(state == 2)		//双倍功德时间
				{	
					P00 = 0;
					Timer0_Init_2S();
					printf("P00灯点亮！\r\n");
				}
				else				//单倍功德时间
				{
					P00 = 0;
					printf("P00灯点亮！\r\n");
					Timer0_Init_1S();
				}
			}
			while(P35 == 0);			//判断按键状态是不是改变了
		}
		
	}
}

//函数定义
void Timer0_Init_1S(void)	//1秒@24.000MHz
{
	TM0PS = 0x1E;			//设置定时器时钟预分频 ( 注意:并非所有系列都有此寄存器,详情请查看数据手册 )
	AUXR &= 0x7F;			//定时器时钟12T模式
	TMOD &= 0xF0;			//设置定时器模式
	TL0 = 0xFC;				//设置定时初始值
	TH0 = 0x03;				//设置定时初始值
	TF0 = 0;				//清除TF0标志
	TR0 = 1;				//定时器0开始计时
	ET0 = 1;				//使能定时器0中断
}

void Timer0_Init_2S(void)	//2秒@24.000MHz
{
	TM0PS = 0x3D;			//设置定时器时钟预分频 ( 注意:并非所有系列都有此寄存器,详情请查看数据手册 )
	AUXR &= 0x7F;			//定时器时钟12T模式
	TMOD &= 0xF0;			//设置定时器模式
	TL0 = 0xFC;				//设置定时初始值
	TH0 = 0x03;				//设置定时初始值
	TF0 = 0;				//清除TF0标志
	TR0 = 1;				//定时器0开始计时
	ET0 = 1;				//使能定时器0中断
}


void Timer0_Isr(void) interrupt 1  							//三秒钟执行一次。
{				
	TR0 = 0;												//关闭定时器
	P00 = 1;												//熄灭LED
	printf("P00灯熄灭！\r\n");
	printf("功德成功点亮！\r\n");
	
	if(state == 1)											//判断功德，加功德
		gongde_count += 1;					
	else
		gongde_count += 2;
	printf("功德+%d 当前功德%d\r\n", state, gongde_count);	//打印功德
}
		